{
    "$graph": [
        {
            "label": "Run tRNAScan, gather",
            "class": "CommandLineTool",
            "baseCommand": "gpx_qdump",
            "arguments": [
                "-unzip",
                "*"
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-input-path"
                    },
                    "id": "#gpx_qdump.cwl/input_path"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "intermediate.asn",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gpx_qdump.cwl/output_name"
                }
            ],
            "id": "#gpx_qdump.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_name)"
                    },
                    "id": "#gpx_qdump.cwl/intermediate"
                }
            ]
        },
        {
            "label": "Run tRNAScan, scatter",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.asn_cache)",
                            "writable": false
                        }
                    ]
                }
            ],
            "baseCommand": "gpx_qsubmit",
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-asn-cache"
                    },
                    "id": "#gpx_qsubmit_trnascan.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "jobs.xml",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#gpx_qsubmit_trnascan.cwl/output"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-ids"
                    },
                    "id": "#gpx_qsubmit_trnascan.cwl/seqids"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output)"
                    },
                    "id": "#gpx_qsubmit_trnascan.cwl/jobs"
                }
            ],
            "id": "#gpx_qsubmit_trnascan.cwl"
        },
        {
            "label": "Run tRNAScan, transform",
            "class": "CommandLineTool",
            "baseCommand": "trnascan_dump",
            "arguments": [
                "-X",
                "20"
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input"
                    },
                    "id": "#trnascan_dump.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "trnascan.asn",
                    "inputBinding": {
                        "prefix": "-oasn"
                    },
                    "id": "#trnascan_dump.cwl/oasn"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "struct.tar.gz",
                    "inputBinding": {
                        "prefix": "-ostruc"
                    },
                    "id": "#trnascan_dump.cwl/ostruct"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.oasn)"
                    },
                    "id": "#trnascan_dump.cwl/outasn"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.ostruct)"
                    },
                    "id": "#trnascan_dump.cwl/outstruct"
                }
            ],
            "id": "#trnascan_dump.cwl"
        },
        {
            "label": "Run tRNAScan, execution",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entry": "$(inputs.asn_cache)",
                            "writable": false
                        }
                    ]
                }
            ],
            "baseCommand": "trnascan_wnode",
            "arguments": [
                "-X",
                "20",
                "-Q",
                "-H",
                "-b",
                "-q",
                "-nogenbank"
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "inputBinding": {
                        "prefix": "-asn-cache"
                    },
                    "id": "#trnascan_wnode.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "/panfs/pan1.be-md.ncbi.nlm.nih.gov/gpipe/ThirdParty/tRNAscan-SE/production/bin/tRNAscan-SE",
                    "inputBinding": {
                        "prefix": "-tRNAscan"
                    },
                    "id": "#trnascan_wnode.cwl/binary"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "valueFrom": "${if (inputs.superkingdom==2157) { return true; } else {return false; } }",
                        "prefix": "-A"
                    },
                    "id": "#trnascan_wnode.cwl/cove_flag_archaea"
                },
                {
                    "type": "boolean",
                    "default": true,
                    "inputBinding": {
                        "valueFrom": "${if (inputs.superkingdom==2)    { return true; } else {return false; } }",
                        "prefix": "-B"
                    },
                    "id": "#trnascan_wnode.cwl/cove_flag_bacteria"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-g"
                    },
                    "id": "#trnascan_wnode.cwl/gcode_othmito"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-input-jobs"
                    },
                    "id": "#trnascan_wnode.cwl/input_jobs"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "output",
                    "inputBinding": {
                        "prefix": "-O"
                    },
                    "id": "#trnascan_wnode.cwl/output_dir"
                },
                {
                    "type": "int",
                    "id": "#trnascan_wnode.cwl/superkingdom"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "-taxid"
                    },
                    "id": "#trnascan_wnode.cwl/taxid"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-taxon-db"
                    },
                    "id": "#trnascan_wnode.cwl/taxon_db"
                }
            ],
            "outputs": [
                {
                    "type": "Directory",
                    "outputBinding": {
                        "glob": "$(inputs.output_dir)"
                    },
                    "id": "#trnascan_wnode.cwl/outdir"
                }
            ],
            "id": "#trnascan_wnode.cwl"
        },
        {
            "class": "Workflow",
            "label": "trnascan_wnode and gpx_qdump combined",
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#wf_scan_and_dump.cwl/asn_cache"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#wf_scan_and_dump.cwl/gcode_othmito"
                },
                {
                    "type": "File",
                    "id": "#wf_scan_and_dump.cwl/input_jobs"
                },
                {
                    "type": "int",
                    "id": "#wf_scan_and_dump.cwl/superkingdom"
                },
                {
                    "type": "int",
                    "id": "#wf_scan_and_dump.cwl/taxid"
                },
                {
                    "type": "File",
                    "id": "#wf_scan_and_dump.cwl/taxon_db"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#wf_scan_and_dump.cwl/Run_tRNAScan_dump/intermediate",
                    "id": "#wf_scan_and_dump.cwl/intermediate"
                }
            ],
            "steps": [
                {
                    "run": "#gpx_qdump.cwl",
                    "in": [
                        {
                            "source": "#wf_scan_and_dump.cwl/Run_tRNAScan_wnode/outdir",
                            "id": "#wf_scan_and_dump.cwl/Run_tRNAScan_dump/input_path"
                        }
                    ],
                    "out": [
                        "#wf_scan_and_dump.cwl/Run_tRNAScan_dump/intermediate"
                    ],
                    "id": "#wf_scan_and_dump.cwl/Run_tRNAScan_dump"
                },
                {
                    "run": "#trnascan_wnode.cwl",
                    "in": [
                        {
                            "source": "#wf_scan_and_dump.cwl/asn_cache",
                            "id": "#wf_scan_and_dump.cwl/Run_tRNAScan_wnode/asn_cache"
                        },
                        {
                            "source": "#wf_scan_and_dump.cwl/gcode_othmito",
                            "id": "#wf_scan_and_dump.cwl/Run_tRNAScan_wnode/gcode_othmito"
                        },
                        {
                            "source": "#wf_scan_and_dump.cwl/input_jobs",
                            "id": "#wf_scan_and_dump.cwl/Run_tRNAScan_wnode/input_jobs"
                        },
                        {
                            "source": "#wf_scan_and_dump.cwl/superkingdom",
                            "id": "#wf_scan_and_dump.cwl/Run_tRNAScan_wnode/superkingdom"
                        },
                        {
                            "source": "#wf_scan_and_dump.cwl/taxid",
                            "id": "#wf_scan_and_dump.cwl/Run_tRNAScan_wnode/taxid"
                        },
                        {
                            "source": "#wf_scan_and_dump.cwl/taxon_db",
                            "id": "#wf_scan_and_dump.cwl/Run_tRNAScan_wnode/taxon_db"
                        }
                    ],
                    "out": [
                        "#wf_scan_and_dump.cwl/Run_tRNAScan_wnode/outdir"
                    ],
                    "id": "#wf_scan_and_dump.cwl/Run_tRNAScan_wnode"
                }
            ],
            "id": "#wf_scan_and_dump.cwl"
        },
        {
            "label": "Run tRNAScan",
            "class": "Workflow",
            "requirements": [
                {
                    "class": "SubworkflowFeatureRequirement"
                },
                {
                    "class": "ScatterFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "Directory",
                    "id": "#main/asn_cache"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "boolean"
                    },
                    "id": "#main/go"
                },
                {
                    "type": "string",
                    "id": "#main/scatter_gather_nchunks"
                },
                {
                    "type": "File",
                    "id": "#main/seqids"
                },
                {
                    "type": "int",
                    "id": "#main/taxid"
                },
                {
                    "type": "File",
                    "id": "#main/taxon_db"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputSource": "#main/Run_tRNAScan_trnascan_dump/outasn",
                    "id": "#main/annots"
                }
            ],
            "steps": [
                {
                    "run": "#compute_gencode.cwl",
                    "in": [
                        {
                            "default": true,
                            "id": "#main/Compute_Gencode_for_trna/gencode"
                        },
                        {
                            "source": "#main/taxid",
                            "id": "#main/Compute_Gencode_for_trna/taxid"
                        },
                        {
                            "source": "#main/taxon_db",
                            "id": "#main/Compute_Gencode_for_trna/taxon_db"
                        }
                    ],
                    "out": [
                        "#main/Compute_Gencode_for_trna/output"
                    ],
                    "id": "#main/Compute_Gencode_for_trna"
                },
                {
                    "run": "#file2int.cwl",
                    "in": [
                        {
                            "source": "#main/Compute_Gencode_for_trna/output",
                            "id": "#main/Compute_Gencode_int_for_trna/input"
                        }
                    ],
                    "out": [
                        "#main/Compute_Gencode_int_for_trna/value"
                    ],
                    "id": "#main/Compute_Gencode_int_for_trna"
                },
                {
                    "run": "#compute_gencode.cwl",
                    "in": [
                        {
                            "default": true,
                            "id": "#main/Compute_Superkingdom_for_trna/superkingdom"
                        },
                        {
                            "source": "#main/taxid",
                            "id": "#main/Compute_Superkingdom_for_trna/taxid"
                        },
                        {
                            "source": "#main/taxon_db",
                            "id": "#main/Compute_Superkingdom_for_trna/taxon_db"
                        }
                    ],
                    "out": [
                        "#main/Compute_Superkingdom_for_trna/output"
                    ],
                    "id": "#main/Compute_Superkingdom_for_trna"
                },
                {
                    "run": "#file2int.cwl",
                    "in": [
                        {
                            "source": "#main/Compute_Superkingdom_for_trna/output",
                            "id": "#main/Compute_Superkingdom_int_for_trna/input"
                        }
                    ],
                    "out": [
                        "#main/Compute_Superkingdom_int_for_trna/value"
                    ],
                    "id": "#main/Compute_Superkingdom_int_for_trna"
                },
                {
                    "run": "#gencode2trnamodel.cwl",
                    "in": [
                        {
                            "source": "#main/Compute_Gencode_int_for_trna/value",
                            "id": "#main/Get_TRNA_model/gencode"
                        }
                    ],
                    "out": [
                        "#main/Get_TRNA_model/output"
                    ],
                    "id": "#main/Get_TRNA_model"
                },
                {
                    "run": "#wf_scan_and_dump.cwl",
                    "scatter": "#main/Run_scan_and_dump/input_jobs",
                    "in": [
                        {
                            "source": "#main/asn_cache",
                            "id": "#main/Run_scan_and_dump/asn_cache"
                        },
                        {
                            "source": "#main/Get_TRNA_model/output",
                            "id": "#main/Run_scan_and_dump/gcode_othmito"
                        },
                        {
                            "source": "#main/split_jobs/jobs",
                            "id": "#main/Run_scan_and_dump/input_jobs"
                        },
                        {
                            "source": "#main/Compute_Superkingdom_int_for_trna/value",
                            "id": "#main/Run_scan_and_dump/superkingdom"
                        },
                        {
                            "source": "#main/taxid",
                            "id": "#main/Run_scan_and_dump/taxid"
                        },
                        {
                            "source": "#main/taxon_db",
                            "id": "#main/Run_scan_and_dump/taxon_db"
                        }
                    ],
                    "out": [
                        "#main/Run_scan_and_dump/intermediate"
                    ],
                    "id": "#main/Run_scan_and_dump"
                },
                {
                    "run": "#gpx_qsubmit_trnascan.cwl",
                    "in": [
                        {
                            "source": "#main/asn_cache",
                            "id": "#main/Run_tRNAScan_submit/asn_cache"
                        },
                        {
                            "source": "#main/seqids",
                            "id": "#main/Run_tRNAScan_submit/seqids"
                        }
                    ],
                    "out": [
                        "#main/Run_tRNAScan_submit/jobs"
                    ],
                    "id": "#main/Run_tRNAScan_submit"
                },
                {
                    "run": "#trnascan_dump.cwl",
                    "in": [
                        {
                            "source": "#main/collect_intermediate/file_out",
                            "id": "#main/Run_tRNAScan_trnascan_dump/input"
                        }
                    ],
                    "out": [
                        "#main/Run_tRNAScan_trnascan_dump/outasn",
                        "#main/Run_tRNAScan_trnascan_dump/outstruct"
                    ],
                    "id": "#main/Run_tRNAScan_trnascan_dump"
                },
                {
                    "run": "#cat_array_of_files.cwl",
                    "in": [
                        {
                            "source": "#main/Run_scan_and_dump/intermediate",
                            "id": "#main/collect_intermediate/files_in"
                        }
                    ],
                    "out": [
                        "#main/collect_intermediate/file_out"
                    ],
                    "id": "#main/collect_intermediate"
                },
                {
                    "run": "#split.cwl",
                    "in": [
                        {
                            "source": "#main/Run_tRNAScan_submit/jobs",
                            "id": "#main/split_jobs/input"
                        },
                        {
                            "source": "#main/scatter_gather_nchunks",
                            "id": "#main/split_jobs/nchunks"
                        }
                    ],
                    "out": [
                        "#main/split_jobs/jobs"
                    ],
                    "id": "#main/split_jobs"
                }
            ],
            "id": "#main"
        },
        {
            "label": "compute_gencode",
            "class": "CommandLineTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "baseCommand": "compute_gencode",
            "inputs": [
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-gencode"
                    },
                    "id": "#compute_gencode.cwl/gencode"
                },
                {
                    "type": "string",
                    "default": "gencode.txt",
                    "inputBinding": {
                        "prefix": "-output"
                    },
                    "id": "#compute_gencode.cwl/output_impl"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-superkingdom"
                    },
                    "id": "#compute_gencode.cwl/superkingdom"
                },
                {
                    "type": "int",
                    "inputBinding": {
                        "prefix": "-taxid"
                    },
                    "id": "#compute_gencode.cwl/taxid"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-taxon-db"
                    },
                    "id": "#compute_gencode.cwl/taxon_db"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.output_impl)"
                    },
                    "id": "#compute_gencode.cwl/output"
                }
            ],
            "id": "#compute_gencode.cwl"
        },
        {
            "class": "ExpressionTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "loadContents": true
                    },
                    "id": "#file2int.cwl/input"
                }
            ],
            "expression": "${ return { \"value\": parseInt(inputs.input.contents) }; }\n",
            "outputs": [
                {
                    "type": "int",
                    "id": "#file2int.cwl/value"
                }
            ],
            "id": "#file2int.cwl"
        },
        {
            "class": "ExpressionTool",
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "int",
                    "id": "#gencode2trnamodel.cwl/gencode"
                }
            ],
            "expression": "${ var gc = inputs.gencode; var gc2 = \"\"; if( gc == 4 ) { gc2=\"othmito\"; } else if ( gc==6 ) { gc2=\"cilnuc\"; } else if ( gc == 9) { gc2 = \"echdmito\" } else if ( gc == 5) { gc2 = \"invmito\"  } else if ( gc == 2) { gc2 = \"vertmito\"  } else if ( gc == 3) { gc2 = \"ystmito\"  } ; if ( gc2 != \"\" ) { return { \"output\": \"/panfs/pan1.be-md.ncbi.nlm.nih.gov/gpipe/ThirdParty/tRNAscan-SE/production/lib/tRNAscan-SE/gcode/gcode.\"+gc2 }; } else { return { \"output\": null }; } }\n",
            "outputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#gencode2trnamodel.cwl/output"
                }
            ],
            "id": "#gencode2trnamodel.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "file concatenation",
            "baseCommand": "cat",
            "stdout": "cat.out",
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#cat_array_of_files.cwl/files_in"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "id": "#cat_array_of_files.cwl/file_out",
                    "outputBinding": {
                        "glob": "cat.out"
                    }
                }
            ],
            "id": "#cat_array_of_files.cwl"
        },
        {
            "class": "CommandLineTool",
            "label": "cwl split wrapper",
            "baseCommand": "split",
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 1,
                        "prefix": "-l"
                    },
                    "id": "#split.cwl/chunk_size"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 4
                    },
                    "id": "#split.cwl/input"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "jobs",
                    "inputBinding": {
                        "position": 5,
                        "valueFrom": "$(inputs.mask)"
                    },
                    "id": "#split.cwl/mask"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "position": 2,
                        "prefix": "-n l//",
                        "separate": false
                    },
                    "id": "#split.cwl/nchunks"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": ".xml",
                    "inputBinding": {
                        "position": 3,
                        "separate": false,
                        "prefix": "--additional-suffix="
                    },
                    "id": "#split.cwl/suffix"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "$(inputs.mask)?*$(inputs.suffix)"
                    },
                    "id": "#split.cwl/jobs"
                }
            ],
            "id": "#split.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
